HDU-2377 Bus Pass

来源:互联网 发布:beauty cam是什么软件 编辑:程序博客网 时间:2024/05/19 18:16

Bus Pass

Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)

Problem Description
You travel a lot by bus and the costs of all the seperate tickets are starting to add up.

Therefore you want to see if it might be advantageous for you to buy a bus pass.

The way the bus system works in your country (and also in the Netherlands) is as follows:

when you buy a bus pass, you have to indicate a center zone and a star value. You are allowed to travel freely in any zone which has a distance to your center zone which is less than your star value. For example, if you have a star value of one, you can only travel in your center zone. If you have a star value of two, you can also travel in all adjacent zones, et cetera.

You have a list of all bus trips you frequently make, and would like to determine the minimum star value you need to make all these trips using your buss pass. But this is not always an easy task. For example look at the following figure:



Here you want to be able to travel from A to B and from B to D. The best center zone is 7400, for which you only need a star value of 4. Note that you do not even visit this zone on your trips!
 

Input
On the first line an integert(1 <=t<= 100): the number of test cases. Then for each test case:

One line with two integersnz(2 <=nz<= 9 999) andnr(1 <=nr<= 10): the number of zones and the number of bus trips, respectively.

nz lines starting with two integers idi (1 <= idi <= 9 999) and mzi (1 <= mzi <= 10), a number identifying the i-th zone and the number of zones adjacent to it, followed by mzi integers: the numbers of the adjacent zones.

nr lines starting with one integer mri (1 <= mri <= 20), indicating the number of zones the ith bus trip visits, followed by mri integers: the numbers of the zones through which the bus passes in the order in which they are visited.

All zones are connected, either directly or via other zones.

 

Output
For each test case:

One line with two integers, the minimum star value and the id of a center zone which achieves this minimum star value. If there are multiple possibilities, choose the zone with the lowest number.

 

Sample Input
117 27400 6 7401 7402 7403 7404 7405 74067401 6 7412 7402 7400 7406 7410 74117402 5 7412 7403 7400 7401 74117403 6 7413 7414 7404 7400 7402 74127404 5 7403 7414 7415 7405 74007405 6 7404 7415 7407 7408 7406 74007406 7 7400 7405 7407 7408 7409 7410 74017407 4 7408 7406 7405 74157408 4 7409 7406 7405 74077409 3 7410 7406 74087410 4 7411 7401 7406 74097411 5 7416 7412 7402 7401 74107412 6 7416 7411 7401 7402 7403 74137413 3 7412 7403 74147414 3 7413 7403 74047415 3 7404 7405 74077416 2 7411 74125 7409 7408 7407 7405 74156 7415 7404 7414 7413 7412 7416


Sample Output
4 7400

 ————————————————————集训2.1的分割线————————————————————

前言:这道题还是比较丧病的。。。用来学习BFS+SPFA+邻接表

思路:首先目的是要找出某一个地区,到达所有车站的最大距离最小。那么反过来对每个车站跑一遍最短路。最坏20次,所以采用SPFA,见效快疗效好。每次跑完之后,得到一份单源最短路。枚举顶点,维护它的最大值,这么一来跑完所有车站之后得到的就是每个顶点和各个车站距离的最大值(最远的车站)。而要求的就是这个最大值最小的点。

PS.SPFA是对Bellman-Ford的改进(增加了队列),本质就是一个BFS。每进行一次松弛操作,都需要使得该松弛点进队,等待松弛。还有一点比较坑:输入的时候id可能不是增序,要输出id最小的还要进行排序。

代码如下:

/*ID: j.sure.1PROG:LANG: C++*//****************************************/#include <cstdio>#include <cstdlib>#include <cstring>#include <algorithm>#include <cmath>#include <stack>#include <queue>#include <vector>#include <map>#include <string>#include <iostream>using namespace std;/****************************************/int n, bus;const int MAXE = 200005, MAXN = 10000;bool inq[MAXN];int dis[MAXN], node[MAXN], maxd[MAXN], head[MAXN], id[MAXN];struct Edge{int u, v;int next;} edge[MAXE];int cnt;void init(){memset(head, -1, sizeof(head));cnt = 0;memset(maxd, 0, sizeof(maxd));}void add(int u, int v){edge[cnt].u = u;edge[cnt].v = v;edge[cnt].next = head[u];head[u] = cnt++;}void spfa(int st){memset(inq, 0, sizeof(inq));memset(dis, 0x7f, sizeof(dis));queue <int> q;q.push(st);dis[st] = 0;inq[st] = true;int tmp;while(!q.empty()) {tmp = q.front(); q.pop();inq[tmp] = false;for(int i = head[tmp]; i != -1; i = edge[i].next) {int v = edge[i].v;if(dis[v] > dis[tmp] + 1) {dis[v] = dis[tmp] + 1;if(!inq[v]) {q.push(v);inq[v] = true;}}}}}int main(){#ifndef ONLINE_JUDGE    freopen("2377.in", "r", stdin);    freopen("2377.out", "w", stdout);#endif    int T;    scanf("%d", &T);    for(int cas = 0; cas < T; cas++) {        scanf("%d%d", &n, &bus);        int adj;        init();        for(int i = 0; i < n; i++) {            scanf("%d%d", &id[i], &adj);            int v;            while(adj--) {scanf("%d", &v);add(id[i], v);//add(v, id[i]);//因为数据齐全所以不需要            }        }        while(bus--) {int stop;scanf("%d", &stop);while(stop--) {int st;scanf("%d", &st);spfa(st);for(int i = 0; i < n; i++) {if(dis[id[i]] > maxd[id[i]]) {maxd[id[i]] = dis[id[i]];}}}        }//如果存在多个解 找到编号最小的int ans = 2e9, ans_id;sort(id, id+n);for(int i = 0; i < n; i++) if(ans > maxd[id[i]]) {ans = maxd[id[i]];ans_id = id[i];}printf("%d %d\n", ans+1, ans_id);    }    return 0;}


0 0
原创粉丝点击
热门问题 老师的惩罚 人脸识别 我在镇武司摸鱼那些年 重生之率土为王 我在大康的咸鱼生活 盘龙之生命进化 天生仙种 凡人之先天五行 春回大明朝 姑娘不必设防,我是瞎子 满月的宝宝黄疸高怎么办 刚满月的宝宝黄疸高怎么办 换奶粉孩子不喝怎么办 宝宝整夜哭闹不睡觉怎么办 满月宝宝整夜不睡觉怎么办 6个半月宝宝一喂粥就哭怎么办 宝宝敷鸡蛋白过敏怎么办 七个月宝宝不吃米糊怎么办 涨奶引起的发烧怎么办 8个月宝宝积食怎么办 宝宝吃奶一会就睡了怎么办 宝宝喝凉酸奶拉肚子怎么办 宝宝戒奶不吃奶粉怎么办 三个月大婴儿不吃奶粉怎么办 三个月大的婴儿不吃奶粉怎么办 40天宝宝肚脐凸怎么办 6个月婴儿消化不好怎么办 2个月婴儿消化不好怎么办 10月婴儿不吃饭怎么办 9个月宝宝不吃饭怎么办 十个多月的宝宝便秘怎么办 十个多月宝宝便秘怎么办 8个月宝宝过敏怎么办 宝宝二十个月便秘怎么办 7个月宝宝便秘拉不出怎么办 二十六个月宝宝便秘怎么办 八个月宝宝吃鸡蛋过敏怎么办 8个月宝宝 吃盐怎么办 40多天婴儿拉肚怎么办 刚出生婴儿拉肚怎么办 20多天婴儿拉肚怎么办 米汤煮的太稠了怎么办 两岁宝宝不吃蔬菜怎么办 两岁宝宝不爱吃蔬菜怎么办 四个月宝宝头有点歪怎么办 宝宝吃过了还闹怎么办 ddrops d3吃多了怎么办 ddrops d3滴多了怎么办 维生素d滴多了怎么办 ddrops最后滴不出来的怎么办 ddrops一次滴3滴怎么办